
SUB ErrorHandler
    _LIMIT 5
    _DEST BufferScreen&
    CLS
    SCREEN BufferScreen&
    IF _INCLERRORFILE$ = "" THEN
        PRINT "Error Code:"; ERR; "in source file: ";: COLOR _RGB(0, 255, 0): PRINT "Main.bas";: COLOR _RGB(255, 255, 255): PRINT " on line:";: COLOR _RGB(0, 0, 255): PRINT _ERRORLINE: COLOR _RGB(255, 255, 255)
    ELSE
        PRINT "Error Code:"; ERR; "in source file: ";: COLOR _RGB(0, 255, 0): PRINT _INCLERRORFILE$;: COLOR _RGB(255, 255, 255): PRINT " on line:";: COLOR _RGB(0, 0, 255): PRINT _INCLERRORLINE: COLOR _RGB(255, 255, 255)
    END IF
    ErrorDescription (ERR)
    PRINT
    PRINT "Resolution:"; Settings.RezX; "x"; Settings.RezY; " Collision Detector:"; Collision
    PRINT "Spawn Data: "; Player1.SpawnData, "Player1.Wait:"; Player1.Wait, "Stage:"; Player1.Stage, "Health:"; Player1.Health
    PRINT
    PRINT "Active Sprite Dump:"
    COLOR _RGB(254, 0, 254)
    PRINT "Player Posx:"; Player1.PosX; "PosY:"; Player1.PosY; "Frame:"; Player1.Frame
    PRINT
    COLOR _RGB(255, 0, 0)
    FOR x = 1 TO 20
        PRINT "Sprite:"; x; Sprites(x).SpriteName; " PosX:"; Sprites(x).PosX; "PosY:"; Sprites(x).PosY; "Active: "; Sprites(x).Active
    NEXT x

    _DEST Overlay&
    CLS
    FOR x = 21 TO 63
        PRINT "Sprite:"; x; Sprites(x).SpriteName; " PosX:"; Sprites(x).PosX; "PosY:"; Sprites(x).PosY; "Active: "; Sprites(x).Active,, "Sprite:"; x + 43; Sprites(x + 43).SpriteName; " PosX:"; Sprites(x + 43).PosX; "PosY:"; Sprites(x + 43).PosY; "Active: "; Sprites(x + 43).Active
    NEXT x

    _DEST SpriteScreen&
    CLS
    FOR x = 107 TO 149
        PRINT "Sprite:"; x; Sprites(x).SpriteName; " PosX:"; Sprites(x).PosX; "PosY:"; Sprites(x).PosY; "Active: "; Sprites(x).Active,, "Sprite:"; x + 43; Sprites(x + 43).SpriteName; " PosX:"; Sprites(x + 43).PosX; "PosY:"; Sprites(x + 43).PosY; "Active: "; Sprites(x + 43).Active
    NEXT x

    DO
        IF _KEYDOWN(15104) THEN SCREEN Display&
        IF _KEYDOWN(15360) THEN SCREEN CollisionData&
        IF _KEYDOWN(15616) THEN SCREEN BufferScreen&
        IF _KEYDOWN(15872) THEN SCREEN Overlay&
        IF _KEYDOWN(16128) THEN SCREEN SpriteScreen&


    LOOP UNTIL _KEYDOWN(27)
    END
END SUB

SUB ErrorDescription (Code)
    IF Code = 1 THEN PRINT "NEXT without FOR: Missing loop end or look for a missing END IF or END SELECT statement."
    IF Code = 2 THEN PRINT "Syntax error: Mistyped keyword statements or puctuation errors can create syntax errors."
    IF Code = 3 THEN PRINT "RETURN without GOSUB: Place sub-procedure line label after program END or EXIT in a SUB-procedure."
    IF Code = 4 THEN PRINT "Out of Data: A READ has read past the end of DATA. Use RESTORE to reset to data start. ."
    IF Code = 5 THEN PRINT "Illegal function call: A parameter passed does not match the function type or exceeds certain function limitations. See Illegal Function."
    IF Code = 6 THEN PRINT "Overflow: A numerical value has exceeded the limitations of a variable type."
    IF Code = 7 THEN PRINT "Out of memory: A module has exceeded the 64K memory limitation of QB. Try breaking the code up to smaller modules."
    IF Code = 8 THEN PRINT "Label not defined: GOTO or GOSUB tries to branch to a label that doesn't exist."
    IF Code = 9 THEN PRINT "Subscript out of range: An array's upper or lower dimensioned boundary has been exceeded."
    IF Code = 52 THEN PRINT "Bad file name or number: The filename must follow the rules for filenames in the OS and use filenumbers from 1 and 255. Use FREEFILE to avoid duplicate OPEN file numbers."
    IF Code = 55 THEN PRINT "File already open: CLOSE a file to open it in a different mode.
    IF Code = 62 THEN PRINT "Input past end of file: Check for the end of file with EOF when reading from a file"
    IF Code = 97 THEN PRINT "Intentional error to cause a dump"
END SUB

