SUB FadeOut
    _DEST Display&
    FOR x = 1 TO 255
        LINE (0, 0)-(Settings.RezX - 1, Settings.RezY - 1), _RGBA(0, 0, 0, x), BF
    NEXT x
END SUB


SUB AnimateStars
    _DEST Background&
    CLS
    FOR Star = 1 TO 45
        IF Starfield(Star).PosZ = 3 THEN
            CIRCLE (Starfield(Star).PosX, Starfield(Star).PosY), 2, _RGB(30, 30, 150)
            PAINT (Starfield(Star).PosX, Starfield(Star).PosY), _RGB(30, 30, 150), _RGB(30, 30, 150)
            Starfield(Star).PosX = Starfield(Star).PosX - 2
            IF Starfield(Star).PosX < 0 THEN Starfield(Star).PosX = Settings.RezX
        END IF

        IF Starfield(Star).PosZ = 2 THEN
            CIRCLE (Starfield(Star).PosX, Starfield(Star).PosY), 3, _RGB(75, 75, 150)
            PAINT (Starfield(Star).PosX, Starfield(Star).PosY), _RGB(75, 75, 150), _RGB(75, 75, 150)
            Starfield(Star).PosX = Starfield(Star).PosX - 5
            IF Starfield(Star).PosX < 0 THEN Starfield(Star).PosX = Settings.RezX
        END IF

        IF Starfield(Star).PosZ = 1 THEN
            CIRCLE (Starfield(Star).PosX, Starfield(Star).PosY), 5, _RGB(150, 150, 150)
            PAINT (Starfield(Star).PosX, Starfield(Star).PosY), _RGB(150, 150, 150), _RGB(150, 150, 150)
            Starfield(Star).PosX = Starfield(Star).PosX - 7
            IF Starfield(Star).PosX < 0 THEN Starfield(Star).PosX = Settings.RezX
        END IF
NEXT Star
END SUB


SUB AssembleDisplay
    _DEST BufferScreen&
    CLS
    _DEST Display&
    _PUTIMAGE , Background&, BufferScreen&
    _PUTIMAGE , SpriteScreen&, BufferScreen&
    _PUTIMAGE , Overlay&, BufferScreen&
    _PUTIMAGE , BufferScreen&, Display&
END SUB


SUB LoadingScreen
    _DEST Display&
    CLS
    LOCATE 12, 1
    PRINT "                                                                          Get Ready!"
END SUB


SUB EndGame
    _LIMIT 5
    _FULLSCREEN _OFF
    CLS
    SCREEN 0
    SCREEN 12
    COLOR 14, 4
    PRINT "                    Developed by ";
    COLOR 14, 1
    PRINT "Pedro Herrera";
    COLOR 14, 4
    PRINT " 2019                             "
    COLOR 15, 4
    PRINT "                                                                                "
    PRINT "Downloaded from http://Craz1000.net                                             "
    PRINT "Source code available there too                                                 "
    PRINT "Programmed and compiled with QB64                                               "
    PRINT "Inspired by Milo Sedlacek's Monospace and old school NES games                  "
    PRINT "                                                                                "
    PRINT "EMAIL: Uaeladen@gmail.com                                                       "
    PRINT "WEB: http://Craz1000.net                                                        "
    PRINT "                                                                                "
    COLOR 15, 0
    PRINT "                                                                                "
    END
END SUB


SUB DrawOverlay
    _DEST Overlay&
    CLS

    IF Settings.DesignerMode = 0 THEN
        LOCATE 45, 47
        IF Player1.Health > 0 THEN
            PRINT "SHIELD:"; Player1.Health
        ELSE
            PRINT "SHIELD: 0"
        END IF
        LOCATE 45, 78
        PRINT "LIVES:"; Player1.Lives
        LOCATE 45, 106
        PRINT "SPECIAL:"; Player1.SLaser
    ELSE
        PRINT "Designer Mode! Stage:"; Player1.Stage
    END IF
    _CLEARCOLOR _RGB(0, 0, 0)
END SUB


SUB GameOver
    TIMER(ReadFileTimer) OFF
    TIMER(FireLazarTimer) OFF
    _DEST Overlay&
    CLS
    _CLEARCOLOR _RGB(0, 0, 0), Overlay&
    KillAllSprites
    CLOSE #1
    FadeOut
    CALL JukeBox2("Level", "Stop")
    CALL JukeBox2("Boss", "Stop")
    _DEST Display&
    CLS
    LOCATE 12, 1

    IF Player1.Won = 1 THEN
        PRINT "                                                                     Thank you for playing!"
    ELSE
        PRINT "                                                                          Game over!"
    END IF
    _SNDPLAY SFX(19)
    _DELAY 5

    FadeOut
    ResetPlayer
    Player1.Lives = 3
    Settings.Menu = 1
    Settings.StageSongLoaded = 0
    Settings.DisableSpawning = 0
    MainMenu
    InitTimers
    KillAllSprites
    CALL JukeBox2("Intro", "Stop")
    LoadStage
    TIMER(ReadFileTimer) ON
    Settings.DisableCollisions = 0
    MainLoop
END SUB

SUB MainMenu
    CALL JukeBox2("Intro", "Loop")
    Settings.Menu = 1
    Player1.Frame = 1
    Settings.DisableCollisions = 1
    PosXTemp = Player1.PosX
    PosYTemp = Player1.PosY
    Player1.PosX = 10
    Player1.PosY = Settings.RezY - 40
    TIMER(MenuLaserTimer) ON
    CALL SetupSprite(Settings.RezX - 20, Settings.RezY - 30, 0, 0, "Ship3", 20, 0, 1, 1, 0, 0, 0, 20)
    TIMER(Shoot) ON
    _LIMIT 60
    _DEST Overlay&

    DO
        _LIMIT 30
        LOCATE 1, 1
        COLOR _RGB(255, 255, 255), _RGB(255, 0, 0)
        PRINT "                                                                    Stereospace                                                                                 "
        PRINT
        COLOR _RGB(255, 255, 255), _RGB(0, 0, 0)
        PRINT Settings.Version
        LOCATE 11, 1
        COLOR _RGB(255, 0, 0)
        PRINT "PRESS ENTER TO START, ESC TO QUIT"
        COLOR _RGB(255, 255, 255)
        IF _KEYDOWN(27) THEN EndGame

        AnimateStars
        DrawSprites
        AssembleDisplay
    LOOP UNTIL _KEYDOWN(13)

    _SNDPLAY SFX(18)
    KillAllSprites
    TIMER(MenuLaserTimer) OFF
    DO
        _LIMIT 30
        Player1.PosX = Player1.PosX + 50
        IF Player1.PosX > Settings.RezX + 100 THEN EXIT DO
        AnimateStars
        DrawSprites
        AssembleDisplay
    LOOP
    Player1.PosX = PosXTemp
    Player1.PosY = PosYTemp
    Settings.DisableSound = 0
    Settings.Menu = 0
    FadeOut
END SUB

