SUB InitEngine
    InitTimers
    ResetPlayer
    Player1.Lives = 3

    FOR Z = 3 TO 1 STEP -1
        FOR Star = 1 TO 15
            Starfield(Star + ((Z * 15) - 15)).PosX = INT(RND * Settings.RezX) + 1
            Starfield(Star + ((Z * 15) - 15)).PosY = INT(RND * Settings.RezY) + 1
            Starfield(Star + ((Z * 15) - 15)).PosZ = Z
        NEXT Star
    NEXT Z

    Overlay& = _NEWIMAGE(Settings.RezX, Settings.RezY, Settings.Bitdepth) 'HUD
    Display& = _NEWIMAGE(Settings.RezX, Settings.RezY, Settings.Bitdepth) 'What player sees
    SpriteScreen& = _NEWIMAGE(Settings.RezX, Settings.RezY, Settings.Bitdepth) 'where sprites are drawn
    Background& = _NEWIMAGE(Settings.RezX, Settings.RezY, Settings.Bitdepth) 'starfield
    BufferScreen& = _NEWIMAGE(Settings.RezX, Settings.RezY, Settings.Bitdepth) 'the screen used to assenble the display screen
    CollisionData& = _NEWIMAGE(Settings.RezX, Settings.RezY, Settings.Bitdepth) 'used to detect collisions

    SCREEN Display&
    _DEST Display&
END SUB

SUB PowerUpDrop (x)
    Drop = INT(RND * 100) + 1

    IF Drop < 5 THEN
        CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -5, 0, "Heal1", 20, 0, 0, 3, 99, 0, 1, 1)
    ELSEIF Drop < 8 THEN
        CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -5, 0, "Heal5", 20, 0, 0, 3, 99, 0, 1, 1)
    ELSEIF Drop < 10 THEN
        CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -5, 0, "Speed", 20, 0, 0, 3, 99, 0, 1, 1)
    ELSEIF Drop < 12 THEN
        CALL SetupSprite(Sprites(x).PosX, Sprites(x).PosY, -5, 0, "SLasp", 20, 0, 0, 3, 99, 0, 1, 1)
    END IF
END SUB

SUB ReadLevel
    Sections = INT(Settings.RezY / 11)
    IF Player1.SpawnData = "wait       " THEN
        Player1.Wait = CheckIfAllDead
    ELSEIF Player1.SpawnData = "end        " THEN
        IF Settings.DesignerMode = 1 THEN GameOver
        Player1.Stageover = 1
        TIMER(ReadFile) OFF
    ELSEIF Player1.SpawnData = "gameover   " THEN
        Player1.Won = 1
        GameOver
    END IF

    IF Player1.Wait = 0 AND Player1.Stageover = 0 THEN
        INPUT #1, Player1.SpawnData

        FOR x = 1 TO 11
            IF MID$(Player1.SpawnData, x, 1) = "1" THEN CALL SetupSprite(Settings.RezX, Settings.RezY - (Sections * x), -3, 0, "Aste1", 20, 0, 0, 3, 99, 0, 5, 1)
            IF MID$(Player1.SpawnData, x, 1) = "2" THEN CALL SetupSprite(Settings.RezX, Settings.RezY - (Sections * x), -3, 0, "Ship1", 20, 0, 0, 1, 0, 0, 0, 1)
            IF MID$(Player1.SpawnData, x, 1) = "3" THEN CALL SetupSprite(Settings.RezX, Settings.RezY - (Sections * x), -3, 0, "Ship2", 20, 0, 0, 1, 0, 0, 0, 1)
            IF MID$(Player1.SpawnData, x, 1) = "4" THEN CALL SetupSprite(Settings.RezX, Settings.RezY - (Sections * x), -30, 5, "Ship3", 20, 0, 0, 1, 0, 0, 0, 1)
            IF MID$(Player1.SpawnData, x, 1) = "5" THEN CALL SetupSprite(Settings.RezX, Settings.RezY - (Sections * x), -5, 7, "Ship4", 20, 0, 0, 1, 0, 0, 0, 2)
            IF MID$(Player1.SpawnData, x, 1) = "6" THEN CALL SetupSprite(Settings.RezX, Settings.RezY - (Sections * x), -5, 7, "Ship5", 20, 0, 0, 1, 0, 0, 0, 2)
            IF MID$(Player1.SpawnData, x, 1) = "7" THEN CALL SetupSprite(Settings.RezX, Settings.RezY - (Sections * x), -5, 7, "Ship6", 20, 0, 0, 1, 0, 0, 0, 2)
            IF MID$(Player1.SpawnData, x, 1) = "8" THEN CALL SetupSprite(Settings.RezX, Settings.RezY - (Sections * x), -5, 7, "Ship7", 20, 0, 0, 1, 0, 0, 0, 3)
            IF MID$(Player1.SpawnData, x, 1) = "9" THEN CALL SetupSprite(Settings.RezX, Settings.RezY - (Sections * x), -5, 7, "Ship8", 20, 0, 0, 1, 0, 0, 0, 3)
            IF MID$(Player1.SpawnData, x, 1) = "!" THEN CALL SetupSprite(Settings.RezX - 100, INT(Settings.RezY / 2), 0, 7, "Boss1", 100, 0, 0, 1, 0, 98, 0, 100)
            IF MID$(Player1.SpawnData, x, 1) = "@" THEN CALL SetupSprite(Settings.RezX - 100, INT(Settings.RezY / 2), 0, 7, "Boss2", 100, 0, 0, 1, 0, 96, 0, 100)
            IF MID$(Player1.SpawnData, x, 1) = "#" THEN CALL SetupSprite(Settings.RezX - 175, INT(Settings.RezY / 2), 0, 7, "Boss3", 150, 0, 0, 1, 0, 96, 0, 100)
        NEXT x
    END IF
END SUB

FUNCTION EmptySprite
    FOR x = 21 TO TotalSprites - 10
        IF Sprites(x).Active = 0 THEN EXIT FOR
    NEXT x
    EmptySprite = x
END FUNCTION

FUNCTION EmptyLaserSprite
    FOR x = 1 TO 20
        IF Sprites(x).Active = 0 THEN EXIT FOR
    NEXT x
    EmptyLaserSprite = x
END FUNCTION

SUB CheckCollision (Collision)
    IF Settings.DisableCollisions = 0 AND Collision > 20 AND Collision <= TotalSprites THEN
        IF Sprites(Collision).SpriteName <> "Ball1" AND LEFT$(Sprites(Collision).SpriteName, 4) <> "Expl" THEN
            IF Sprites(Collision).SpriteName = "Heal1" AND Sprites(Collision).Active = 1 THEN
                _SNDPLAY SFX(14)
                Player1.Health = Player1.Health + 1
                Sprites(Collision).Active = 0
            ELSEIF Sprites(Collision).SpriteName = "Heal5" AND Sprites(Collision).Active = 1 THEN
                _SNDPLAY SFX(15)
                Player1.Health = Player1.Health + 5
                Sprites(Collision).Active = 0
            ELSEIF Sprites(Collision).SpriteName = "Speed" AND Sprites(Collision).Active = 1 THEN
                _SNDPLAY SFX(16)
                Player1.Speed = Player1.Speed + .1
                Sprites(Collision).Active = 0
            ELSEIF Sprites(Collision).SpriteName = "SLasp" AND Sprites(Collision).Active = 1 THEN
                _SNDPLAY SFX(17)
                Player1.SLaser = Player1.SLaser + 1
                IF Player1.SLaser > 5 THEN Player1.SLaser = 5
                Sprites(Collision).Active = 0
            ELSEIF Sprites(Collision).Active = 1 THEN
                Sprites(Collision).Health = 0
                Player1.Health = 0
            END IF
        END IF
    END IF
END SUB

FUNCTION CheckIfAllDead
    CheckIfAllDead = 0
    IF Sprites(21).Active = 1 AND Sprites(21).SpriteName = "Laser" THEN Sprites(21).Active = 0
    FOR x = 20 TO TotalSprites
        IF Sprites(x).Active = 1 THEN
            CheckIfAllDead = 1
            EXIT FOR
        END IF
    NEXT x
END FUNCTION


SUB ResetPlayer
    Player1.PosX = 25
    Player1.PosY = INT(Settings.RezY / 2)
    Player1.Health = 5
    Player1.Speed = .8
    Player1.SLaser = 0
    Player1.Locked = 0
    Player1.SpawnData = ""
    Player1.NoDraw = 0
    Player1.Wait = 0
    Player1.Won = 0
    Player1.Dead = 0
END SUB



SUB LoadStage
    LoadingScreen
    CLOSE #1
    IF Player1.Stage = 1 THEN
        OPEN "Stages\1.txt" FOR INPUT AS #1
    ELSEIF Player1.Stage = 2 THEN
        OPEN "Stages\2.txt" FOR INPUT AS #1
    ELSEIF Player1.Stage = 3 THEN
        OPEN "Stages\3.txt" FOR INPUT AS #1
    ELSEIF Player1.Stage = 4 THEN
        OPEN "Stages\4.txt" FOR INPUT AS #1
    ELSEIF Player1.Stage = 5 THEN
        OPEN "Stages\5.txt" FOR INPUT AS #1
    ELSEIF Player1.Stage = 6 THEN
        OPEN "Stages\6.txt" FOR INPUT AS #1
    END IF
    StartFile
    _DELAY 5
    FadeOut
    TIMER(ReadFileTimer) ON
END SUB

SUB DeadPlayerTimers
    TIMER(ReadFileTimer) OFF
    TIMER(FireLazarTimer) OFF
    TIMER(PlayerDeadTimer) ON
END SUB

SUB InitTimers
    ReadFileTimer = _FREETIMER
    PlayerDeadTimer = _FREETIMER
    FireLazarTimer = _FREETIMER
    MenuTimer = _FREETIMER
    ON TIMER(ReadFileTimer, 1) ReadLevel
    ON TIMER(MenuLaserTimer, 2) MenuFire
    ON TIMER(PlayerDeadTimer, 5) ResetStage
    ON TIMER(FireLazarTimer, 0.1) FireLazar
END SUB

SUB StartFile
    INPUT #1, Track$
    IF Settings.StageSongLoaded = 0 THEN
        CALL JukeBox2("Music\" + Track$, "Insert")
        CALL JukeBox2("Intro", "Stop")
        Settings.StageSongLoaded = 1
    ELSE
        CALL JukeBox2("Level", "Stop")
        CALL JukeBox2("Boss", "Stop")
    END IF
    CALL JukeBox2("Level", "Play")
END SUB

SUB ResetStage
    TIMER(PlayerDeadTimer) OFF
    Player1.Lives = Player1.Lives - 1
    IF Player1.Lives = -1 THEN GameOver
    FadeOut
    _DEST SpriteScreen&
    CLS
    _DEST Display&
    SEEK 1, 1
    KillAllSprites
    LoadingScreen
    StartFile
    ResetPlayer
    Settings.DisableSpawning = 0
    INPUT #1, Junk$
    _DELAY 6
    FadeOut
    TIMER(ReadFileTimer) ON
END SUB



